        subroutine NT(etot1d,v1d,dir,r,r0,prob,
     &                natom,nsurf,ilower,iupper,keyhop,
     &                rb,eb,rt,et,sigma,delta,gamma,aa,
     &                t1,t2,t1l,t1r,is0,del11,del22)
        implicit none
*
        real*8 etot1d,v1d,dir(3,*),r(3,*),r0,sigma,delta,prob
        integer natom,nsurf,ilower,iupper,keyhop, is0
*
        integer,parameter :: ndvr=50
        real*8, parameter :: twolog10=4.60517018599d0
*
        include 'para.inc'
*
        real*8 ead(msurf)
        real*8 xx(ndvr+3),ww(ndvr+3)
        real*8 redm
        common /redmass/redm
        real*8 err_rel
        common/err_rel/err_rel
        real*8 tafter
        common/bafter/tafter  !0: vel is directed to the barrier
        integer keyveldir
        common/veldir/keyveldir
*
        real*8 rt,et,rb,eb,de,dr,temp,gamma
        real*8 aa,bb,a,g,p,tl,tr,cc,g4,deg,g5,h2
        real*8 aaa,bbb,ccc,res,g6,sigmac,da
        real*8 x,y,kf,gr,gi
        real*8 a07,a21,ss,UIm,URe
        real*8,external :: bfun,gammln,arggam
        real*8 psi,phi,phibar
        real*8 k1_rt,k2_rb,t1,t2,t1l,t1r
        real*8 del11,del12,del22,sigmazero,one_thr
        complex*16 u1,u2
        integer ierr,jerr
*
        kf=1
        prob=0.d0
        keyhop=0
*
        if(et.gt.eb) then
          write(*,'(a,1p2e15.7)') 'et > eb, et,eb=',et,eb
          return
        endif
        de=eb-et
        dr=rb-rt
        write(*,*)'etot1d = ',etot1d
        write(*,*)'rt = ',rt
        write(*,*)'rb = ',rb
        write(*,*)'et = ',et
        write(*,*)'eb = ',eb
        bb=(2.d0*etot1d-eb-et)/de               !
        write(*,'(a,1p3e15.7)') 'redm,de,dr=',redm,de,dr
        write(*,'(a,1p3e15.7)') 'gamma,aa,bb=',gamma,aa,bb

        if(aa.le.0)then
        keyhop=0
        prob=0.d0
        return
        endif
*
        write(*,*) 'etot1d,eb=',etot1d,eb
        if(etot1d.ge.eb)then
        keyhop=3
* ----  Psmall ----
          a=dsqrt(aa)
          g=bb+dsqrt(bb*bb-0.72d0+0.62*a**1.43)            ! bb>0
          p=dsqrt(2.0d0/(aa*g))
          p=exp(-0.25d0*Pi*p)
        prob=p
* ----  DELTA ----
        delta=pi/16.d0/dsqrt(aa*bb)
        temp=dsqrt(1.d0-1.d0/bb/bb)
        delta=delta*dsqrt(6.d0+10.d0*temp)/(1.d0+temp)
        temp=delta/pi
        x=0.0d0
        y=temp
        call cgama(x,y,kf,gr,gi)
        phi=-temp+temp*dlog(temp)-datan(gi/gr)-0.25d0*pi
        phibar=phi+0.23d0*((aa)*0.25d0)*(40.0d0**(-sigma))
     &         /(((aa)**0.25d0)+0.75d0)
        psi=sigma-phibar
        k1_rt=dsqrt(2.0d0*(etot1d-et))
        k2_rb=dsqrt(2.0d0*(etot1d-eb))
        sigmazero=(0.5d0*(rb-rt))*(k1_rt+k2_rb+((k1_rt-k2_rb)**2.0d0
     &             /(3.0d0*(k1_rt+k2_rb))))

        if ((is0==ilower) .and. (t1/=0.0d0) .and. (t2/=0.0d0)) then
* ---- Pbig ----
        del11=2.0d0*(del11-sigmazero) 
        del22=2.0d0*(del22+sigmazero) 
        del12=sigma 
        cc=dcos(psi)
        cc=4.d0*cc*cc
        prob=p*p/(1.d0-p)
        prob=cc/(cc+prob)
        u1=((0.0d0,1.0d0)*dsqrt(1-p))
     &     *cdexp((0.0d0,1.0d0)*(psi))
        u2=2.0d0*(0.0d0,1.0d0)*dimag(u1)
     &     /(cdabs(u1)*cdabs(u1)-1.0d0)

        else
          del11=0.0d0
          del12=0.0d0
          del22=0.0d0
          u1=(0.0d0,0.0d0)
          u2=(0.0d0,0.0d0)
        endif
        write(*,*) 'prob in NT=',prob
        write(*,*) 'phi in NT=',phi
        write(*,*) 'phibar in NT=',phibar
        write(*,*) 'psi in NT=',psi
        write(*,*) 'sigma in NT=',sigma
        write(*,*) 'sigmazero in NT=',sigmazero
        write(*,*) 'delta in NT=',delta
        write(*,*) 'del11 in NT=',del11
        write(*,*) 'del12 in NT=',del12
        write(*,*) 'del22 in NT=',del22
        write(*,*) 'u1 in NT=',u1
        write(*,*) 'u2 in NT=',u2
        write(*,*) 'a,g,pi,p=',a,g,pi,p
        return
* ---------------------------------------------------------------------------                
        elseif(etot1d.ge.et)then
        keyhop=4
        write(*,*)'keyhop=',keyhop
        temp=dsqrt(aa)
        g4=(temp-3.d0*bb)/(temp+3.d0)*
     &       dsqrt(1.23d0+bb)
        deg=1.2d0-0.4d0*bb
        g5=0.38d0*(1.d0+bb)**deg/aa
        temp=aa**0.333333333333333d0        ! a^(2/3)
        one_thr=1.0d0/3.0d0
        a=dsqrt(aa)
        a07=a**0.7d0
        a21=a**2.1d0
c
        aaa=bb/temp
c
        bbb=0.61d0*dsqrt(2.d0+bb)*temp/g4 
c
        ccc=dsqrt(aa)/g4 
c
        call omega(aaa,bbb,ccc,res,jerr)
        if(jerr.eq.-1)then
        prob=0.d0
        keyhop=0
        return
        endif

        res=res*(1.d0+g5)/temp
c
        res=res*res
        prob=res/(1.d0+res)

        k1_rt=dsqrt(2.0d0*(etot1d-et)) 
        sigmazero=-one_thr*(rt-rb)*k1_rt*(1.0d0+bb) 
        sigma=-1.0d0/dsqrt(aa)*(0.057d0*((1.0d0+bb)**0.25d0)+one_thr)
     &          *(1.0d0-bb)*dsqrt(5.0d0+3.0d0*bb) 
        delta=1.0d0/dsqrt(aa)*(0.057d0*((1.0d0-bb)**0.25d0)+one_thr)
     &         *(1.0d0+bb)*dsqrt(5.0d0-3.0d0*bb) 
        h2=0.34d0*a07*(a07+0.35d0)/(a21+0.73d0) 
        h2=h2*(0.42d0+bb) 
        h2=h2*(2.0d0+(100d0*bb/(100d0+aa)))*0.25d0 

        del12=sigma 
        del11=sigma-2.0d0*sigmazero 
        del22=sigma+2.0d0*sigmazero 

        temp=delta/pi 
        x=0.5d0 
        y=temp 
        call cgama(x,y,kf,gr,gi) 
        phi=sigma+datan(gi/gr)-temp*dlog(temp)+temp-h2 
        u1=((dsqrt(1.0d0+res))
     &      *cdexp((0.0d0,1.0d0)*phi)-1.0d0)/dsqrt(res) 
        u1=u1*(0.0d0,1.0d0) 
        u2=2.0d0*(0.0d0,1.0d0)*dimag(u1)
     &      /(cdabs(u1)*cdabs(u1)-1.0d0) 

        write(*,*) 'prob in NT=',prob
        write(*,*) 'phi in NT=',phi 
        write(*,*) 'phibar in NT=',phibar 
        write(*,*) 'psi in NT=',psi 
        write(*,*) 'sigma in NT=',sigma 
        write(*,*) 'sigmazero in NT=',sigmazero 
        write(*,*) 'delta in NT=',delta 
        write(*,*) 'del11 in NT=',del11 
        write(*,*) 'del12 in NT=',del12 
        write(*,*) 'del22 in NT=',del22 
        write(*,*) 'u1 in NT=',u1 
        write(*,*) 'u2 in NT=',u2 
        write(*,*) 'a,g,pi,p=',a,g,pi,p 
        return

        else

        keyhop=5
* ----  Tunneling Integral ----
        keyveldir=1
        if(v1d*rt.gt.0.d0)then
        keyveldir=0
        tafter=t1l
        if(rt.gt.0.d0)tafter=t1r
        endif

        temp=twolog10/aa+delta
        g6=0.32d0*dexp(-temp)                           ! g6
*
        sigma=pi/16.d0/dsqrt(-aa*bb)                   ! sigma
        temp=dsqrt(1.d0-1.d0/bb/bb)
        sigma=sigma*dsqrt(6.d0+10.d0*temp)/(1.d0+temp)
        temp=delta/pi
*
        sigmac=sigma*(1.d0-g6)                         ! sigmac
* ----  Probability ------
        da=1.d0/dsqrt(aa)
        temp=bfun(sigmac/pi)
        temp=temp*dexp(-2.d0*delta)
        prob=0.5d0*temp/(1.d0+da)+1.d0
        prob=temp/(temp+prob*prob)

        a=dsqrt(aa)
        ss=dsin(2.0d0*sigmac)
        cc=dcos(2.0d0*sigmac) 
        temp=bfun(sigmac/pi)
        URe=(0.5d0*a/(1.0d0+a))
     &        *dsqrt(temp)*dexp(-delta)+dexp(delta)/dsqrt(temp)
        URe=URe*ss 
        UIm=dsqrt((URe*URe/ss*ss)+1.0d0/(cc*cc)) 
        UIm=UIm*cc
        UIm=UIm-1.0d0/(2.0d0*dsin(sigmac))*dabs(URe/dcos(sigmac))
        u1=cmplx(URe,UIm) 
        u2=2.0d0*(0.0d0,1.0d0)*dimag(u1)
     &      /(cdabs(u1)*cdabs(u1)-1.0d0)

        del11=-2.0d0*sigma
        del12=-2.0d0*sigma
        del22=-2.0d0*sigma

        write(*,*) 'prob in NT=',prob
        write(*,*) 'phi in NT=',phi
        write(*,*) 'phibar in NT=',phibar
        write(*,*) 'psi in NT=',psi
        write(*,*) 'sigma in NT=',sigma
        write(*,*) 'sigmazero in NT=',sigmazero
        write(*,*) 'delta in NT=',delta
        write(*,*) 'del11 in NT=',del11
        write(*,*) 'del12 in NT=',del12
        write(*,*) 'del22 in NT=',del22
        write(*,*) 'u1 in NT=',u1
        write(*,*) 'u2 in NT=',u2
        write(*,*) 'a,g,pi,p=',a,g,pi,p

        return

        endif
      end
