      subroutine calvdv(q,vq,dvdq,natom,nsurf,isurf1,isurf2,idgrad)
      implicit none
      include 'para.inc'
      include 'atom.inc'
      integer natom,nsurf,isurf1,isurf2,idgrad
      real*8 q(3,*),vq(*),dvdq(3,*)
      real*8 r_c(3,matom)
      real*8 dvdx_c(3,matom)
      real*8 nacme_c(3,matom)
      real*8 tdm_c(3,msurf)
*
      real*8 fac
      integer iatom,k
      integer, parameter :: idbg=0,idum=1
*
      call getrc(q,r_c,natom)
*
      if (idgrad == 0) then
        call run_molpro(r_c,vq,dvdx_c,nacme_c,tdm_c,
     &                  natom,nsurf,isurf1,idum,1)
      else if (idgrad == 1) then
        call run_molpro(r_c,vq,dvdx_c,nacme_c,tdm_c,
     &                  natom,nsurf,isurf1,isurf2,3)
      endif
*
      if (idbg == 1) then
        write(*,*) 'analytical'
        call outrxyz(dvdx_c,natom)
      endif
*
      if (imw == 1) then
        do iatom=1,natom
          fac=1.0d0/sqrt(mass(iatom))
          do k=1,3
            dvdq(k,iatom)=fac*dvdx_c(k,iatom)
          enddo
        enddo
*
      endif
*
      end
